org.jgroups.protocols.pbcast

## Class STREAMING_STATE_TRANSFER

- java.lang.Object
- - org.jgroups.stack.Protocol
  - - org.jgroups.protocols.pbcast.STREAMING_STATE_TRANSFER

-     public class STREAMING_STATE_TRANSFER
      extends Protocol

  `STREAMING_STATE_TRANSFER`, as its name implies, allows a streaming state transfer between two channel instances.

  Major advantage of this approach is that transferring application state to a joining member of a group does not entail loading of the complete application state into memory. Application state, for example, might be located entirely on some form of disk based storage. The default `STATE_TRANSFER` requires this state to be loaded entirely into memory before being transferred to a group member while `STREAMING_STATE_TRANSFER` does not. Thus `STREAMING_STATE_TRANSFER` protocol is able to transfer application state that is very large (>1Gb) without a likelihood of such transfer resulting in OutOfMemoryException.

  `STREAMING_STATE_TRANSFER` allows use of either default channel transport or separate tcp sockets for state transfer. If firewalls are not a concern then separate tcp sockets should be used as they offer faster state transfer. Transport for state transfer is selected using `use_default_transport`boolean property.``

  Channel instance can be configured with either `STREAMING_STATE_TRANSFER` or `STATE_TRANSFER` but not both protocols at the same time.

  In order to process streaming state transfer an application has to implement `ExtendedMessageListener` if it is using channel in a push style mode or it has to process `StreamingSetStateEvent` and `StreamingGetStateEvent` if it is using channel in a pull style mode.

  Since:
    2.4
  Author:
    Vladimir Blagojevic
  See Also:
    `ExtendedMessageListener`, `StreamingGetStateEvent`, `StreamingSetStateEvent`, `STATE_TRANSFER`

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `static class` | `STREAMING_STATE_TRANSFER.StateHeader`

  - ### Field Summary

    Fields
    Modifier and Type | Field and Description
    --- | ---
    `protected java.lang.String` | `bind_interface_str`

    - ### Fields inherited from class org.jgroups.stack.Protocol

      `down_prot, ergonomics, id, log, name, stack, stats, up_prot`

  - ### Constructor Summary

    Constructors
    Constructor and Description
    `STREAMING_STATE_TRANSFER()`

  - ### Method Summary

    Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.lang.Object` | `down(Event evt)` An event is to be sent down the stack.
    `double` | `getAverageStateSize()`
    `long` | `getNumberOfStateBytesSent()`
    `int` | `getNumberOfStateRequests()`
    `void` | `init()` Called after instance has been created (null constructor) and before protocol is started.
    `java.util.Vector<java.lang.Integer>` | `requiredDownServices()` List of events that are required to be answered by some layer below.
    `void` | `resetStats()`
    `void` | `start()` This method is called on a `Channel.connect(String)`.
    `void` | `stop()` This method is called on a `Channel.disconnect()`.
    `java.lang.Object` | `up(Event evt)` An event was received from the layer below.

    - ### Methods inherited from class org.jgroups.stack.Protocol

      `destroy, downThreadEnabled, dumpStats, enableStats, getConfigurableObjects, getDownProtocol, getId, getLevel, getName, getProperties, getProtocolStack, getSocketFactory, getThreadFactory, getTransport, getUpProtocol, getValue, isErgonomics, printStats, providedDownServices, providedUpServices, requiredUpServices, setDownProtocol, setErgonomics, setId, setLevel, setProperties, setPropertiesInternal, setProperty, setProtocolStack, setSocketFactory, setUpProtocol, setValue, setValues, statsEnabled, upThreadEnabled`

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Field Detail

    - #### bind_interface_str

          protected java.lang.String bind_interface_str

  - ### Constructor Detail

    - #### STREAMING_STATE_TRANSFER

          public STREAMING_STATE_TRANSFER()

  - ### Method Detail

    - #### getNumberOfStateRequests

          public int getNumberOfStateRequests()

    - #### getNumberOfStateBytesSent

          public long getNumberOfStateBytesSent()

    - #### getAverageStateSize

          public double getAverageStateSize()

    - #### requiredDownServices

          public java.util.Vector<java.lang.Integer> requiredDownServices()

      Description copied from class: `Protocol`
      List of events that are required to be answered by some layer below.
      Overrides:
        `requiredDownServices` in class `Protocol`
      Returns:
        Vector (of Integers)

    - #### resetStats

          public void resetStats()

      Overrides:
        `resetStats` in class `Protocol`

    - #### init

          public void init()
                    throws java.lang.Exception

      Description copied from class: `Protocol`
      Called after instance has been created (null constructor) and before protocol is started. Properties are already set. Other protocols are not yet connected and events cannot yet be sent.
      Overrides:
        `init` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be initialized successfully. This will cause the ProtocolStack to fail, so the channel constructor will throw an exception

    - #### start

          public void start()
                     throws java.lang.Exception

      Description copied from class: `Protocol`
      This method is called on a `Channel.connect(String)`. Starts work. Protocols are connected and queues are ready to receive events. Will be called from bottom to top. This call will replace the START and START_OK events.
      Overrides:
        `start` in class `Protocol`
      Throws:
        `java.lang.Exception` - Thrown if protocol cannot be started successfully. This will cause the ProtocolStack to fail, so `Channel.connect(String)` will throw an exception

    - #### stop

          public void stop()

      Description copied from class: `Protocol`
      This method is called on a `Channel.disconnect()`. Stops work (e.g. by closing multicast socket). Will be called from top to bottom. This means that at the time of the method invocation the neighbor protocol below is still working. This method will replace the STOP, STOP_OK, CLEANUP and CLEANUP_OK events. The ProtocolStack guarantees that when this method is called all messages in the down queue will have been flushed
      Overrides:
        `stop` in class `Protocol`

    - #### up

          public java.lang.Object up(Event evt)

      Description copied from class: `Protocol`
      An event was received from the layer below. Usually the current layer will want to examine the event type and - depending on its type - perform some computation (e.g. removing headers from a MSG event type, or updating the internal membership list when receiving a VIEW_CHANGE event). Finally the event is either a) discarded, or b) an event is sent down the stack using `down_prot.down()` or c) the event (or another event) is sent up the stack using `up_prot.up()`.
      Overrides:
        `up` in class `Protocol`

    - #### down

          public java.lang.Object down(Event evt)

      Description copied from class: `Protocol`
      An event is to be sent down the stack. The layer may want to examine its type and perform some action on it, depending on the event's type. If the event is a message MSG, then the layer may need to add a header to it (or do nothing at all) before sending it down the stack using `down_prot.down()`. In case of a GET_ADDRESS event (which tries to retrieve the stack's address from one of the bottom layers), the layer may need to send a new response event back up the stack using `up_prot.up()`.
      Overrides:
        `down` in class `Protocol`

Copyright © 1998-2009 Bela Ban / Red Hat. All Rights Reserved.